--- cryptroot.old
+++ cryptroot.new
@@ -277,11 +277,25 @@
 			fi
 		fi
 
+		if [ ! -e "$NEWROOT" ]; then
+			# If we've already seen a phrase, try it first
+			if [ -n "$passphrase" ]; then
+				echo "Trying previously-entered passphrase..."
+				crypttarget="$crypttarget" cryptsource="$cryptsource" echo -n "$passphrase" | $cryptcreate --key-file=-
+				ec="$?"
+				if [ "$ec" -eq 0 ]; then
+					echo "Succeeded with previous passphrase."
+				else
+					echo "Failed with previous passphrase; continuing to passphrase input script."
+				fi
+			fi
+		fi
 
 		if [ ! -e "$NEWROOT" ]; then
-			if ! crypttarget="$crypttarget" cryptsource="$cryptsource" \
-			     $cryptkeyscript "$cryptkey" | $cryptcreate --key-file=- ; then
+			passphrase="$(crypttarget="$crypttarget" cryptsource="$cryptsource" $cryptkeyscript "$cryptkey")"
+			if ! crypttarget="$crypttarget" cryptsource="$cryptsource" echo -n "$passphrase" | $cryptcreate --key-file=- ; then
 				message "cryptsetup: cryptsetup failed, bad password or options?"
+				passphrase=''
 				continue
 			fi
 		fi
